/*
---------------------------------------
All rights reserved
(C) copyright 2002 Gogul Balakrishnan
---------------------------------------
This is a part of the OS, Gogul is writing currently. Permission to use, copy, modify and distribute this software and documentation is granted without fee, provided this copyright message appears on all distributions.I make no representations of the suitability of the software for any purpose whatsoever. It is provided "as is" without any express or implied warranty.

*/

#include <defs.h>
#include <keyb.h>



/*Assumption: ds has the IVT selector */
void insert_idt_desc(BYTE intrno,WORD sel,DWORD fn_ptr/*offset*/,BYTE priv,BYTE type){
	DWORD lo,hi;
	DWORD ptr;
	lo=(sel << 16) | (fn_ptr & 0xffff);
	hi=(fn_ptr & 0xffff0000) | (0xee00);
	ptr=(intrno << 3);
	*((DWORD *)ptr)=lo;
	*((DWORD *)(ptr+4))=hi;
}

void printexptn(BYTE exptn) {
	BYTE *pos=(BYTE *)0;
	__asm__("push %ds
			 mov $0x18,%eax
			 mov %eax,%ds");
	*pos=exptn;
	__asm__("pop %ds
			 mov %ebp,%esp");
}

void int_00h_handler(void) {
	printexptn('A'+0);
	__asm__("sti"); 
	while(1){}
}
void int_01h_handler(void) {
	printexptn('A'+1);
	__asm__("sti"); 
	while(1){}
}
void int_02h_handler(void) {
	printexptn('A'+2);
	__asm__("sti"); 
	while(1){}
}
void int_03h_handler(void) {
	printexptn('A'+3);
	__asm__("sti"); 
	while(1){}
}
void int_04h_handler(void) {
	printexptn('A'+4);
	__asm__("sti"); 
	while(1){}
}

void int_05h_handler(void) {
	printexptn('A'+0x05);
	__asm__("sti"); 
	while(1){}
}

void int_06h_handler(void) {
	printexptn('A'+0x06);
	__asm__("sti"); 
	while(1){}
}

void int_07h_handler(void) {
	printexptn('A'+0x07);
	__asm__("sti"); 
	while(1){}
}

void int_08h_handler(void) {
	printexptn('A'+0x08);
	__asm__("sti"); 
	while(1){}
}

void int_09h_handler(void) {
	printexptn('A'+0x09);
	__asm__("sti"); 
	while(1){}
}

void int_0ah_handler(void) {
	printexptn('A'+0x0a);
	__asm__("sti"); 
	while(1){}
}

void int_0bh_handler(void) {
	printexptn('A'+0x0b);
	__asm__("sti"); 
	while(1){}
}

void int_0ch_handler(void) {
	printexptn('A'+0x0c);
	__asm__("sti"); 
	while(1){}
}

void int_0dh_handler(void) {
	printexptn('A'+0x0d);
	__asm__("sti"); 
	while(1){}
}

void int_0eh_handler(void) {
	printexptn('A'+0x0e);
	__asm__("sti"); 
	while(1){}
}

void int_0fh_handler(void) {
	printexptn('A'+0x0f);
	__asm__("sti"); 
	while(1){}
}

void int_10h_handler(void) {
	printexptn('A'+0x10);
	__asm__("sti"); 
	while(1){}
}

void timer_isr(void) {
	/* HARDCODED SCRSEL */
	BYTE *pos=(BYTE *)2;
	__asm__("push %ds");
	__asm__("mov %0,%%eax"::"g"(SCR_SEL):"%eax");
	__asm__("mov %eax,%ds");
	
	*pos=*pos+1;

	outb(0x20,0x20); //Send non specific EOI to 8259
	__asm__("
		leave
		sti
		iret");
}
/*
void int_keyb_handler() {
	outb(0x20,0x20);
	__asm("mov %ebp, %esp
			pop %ebp 
			sti
			iret");
}
*/


void setup_idt(){
	__asm__("push %ds
		 mov $0x10,%eax
		 mov %eax,%ds");
	insert_idt_desc(0,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(1,KERNEL_CS_SEL,(DWORD)int_01h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(2,KERNEL_CS_SEL,(DWORD)int_02h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(3,KERNEL_CS_SEL,(DWORD)int_03h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(4,KERNEL_CS_SEL,(DWORD)int_04h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(5,KERNEL_CS_SEL,(DWORD)int_05h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(6,KERNEL_CS_SEL,(DWORD)int_06h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(7,KERNEL_CS_SEL,(DWORD)int_07h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(8,KERNEL_CS_SEL,(DWORD)int_08h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(9,KERNEL_CS_SEL,(DWORD)int_09h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0xa,KERNEL_CS_SEL,(DWORD)int_0ah_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0xb,KERNEL_CS_SEL,(DWORD)int_0bh_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0xc,KERNEL_CS_SEL,(DWORD)int_0ch_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0xd,KERNEL_CS_SEL,(DWORD)int_0dh_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0xe,KERNEL_CS_SEL,(DWORD)int_0eh_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0xf,KERNEL_CS_SEL,(DWORD)int_0fh_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x10,KERNEL_CS_SEL,(DWORD)int_10h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x11,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x12,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x13,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x14,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x15,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x16,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x17,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x18,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x19,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	
	insert_idt_desc(TIMER_INTR,KERNEL_CS_SEL,(DWORD)timer_isr,PRIV_USER,INTR_GATE);
	insert_idt_desc(KEYB_INTR,KERNEL_CS_SEL,(DWORD)int_keyb_handler,PRIV_USER,INTR_GATE);
	
	insert_idt_desc(0x22,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x23,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x24,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x25,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x26,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x27,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x28,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x29,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x2a,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x2b,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x2c,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x2d,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x2e,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
	insert_idt_desc(0x2f,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);


/*	for(i=32;i<=0xff;++i)
		insert_idt_desc(i,KERNEL_CS_SEL,(DWORD)int_00h_handler,PRIV_USER,INTR_GATE);
*/
	__asm__("pop %ds");
}


